class emboss:
    def __init__(self):
        self.styles = {
            "bold": {
                "a": "𝐚", "b": "𝐛", "c": "𝐜", "d": "𝐝", "e": "𝐞", "f": "𝐟", "g": "𝐠", "h": "𝐡", "i": "𝐢", "j": "𝐣",
                "k": "𝐤", "l": "𝐥", "m": "𝐦", "n": "𝐧", "o": "𝐨", "p": "𝐩", "q": "𝐪", "r": "𝐫", "s": "𝐬", "t": "𝐭",
                "u": "𝐮", "v": "𝐯", "w": "𝐰", "x": "𝐱", "y": "𝐲", "z": "𝐳",
                "A": "𝐴", "B": "𝐵", "C": "𝐶", "D": "𝐷", "E": "𝐸", "F": "𝐹", "G": "𝐺", "H": "𝐻", "I": "𝐼", "J": "𝐽",
                "K": "𝐾", "L": "𝐿", "M": "𝑀", "N": "𝑁", "O": "𝑂", "P": "𝑃", "Q": "𝑄", "R": "𝑅", "S": "𝑆", "T": "𝑇",
                "U": "𝑈", "V": "𝑉", "W": "𝑊", "X": "𝑋", "Y": "𝑌", "Z": "𝑍"
            },
            "italic": {
                "a": "𝑎", "b": "𝑏", "c": "𝑐", "d": "𝑑", "e": "𝑒", "f": "𝑓", "g": "𝑔", "h": "ℎ", "i": "𝑖", "j": "𝑗",
                "k": "𝑘", "l": "𝑙", "m": "𝑚", "n": "𝑛", "o": "𝑜", "p": "𝑝", "q": "𝑞", "r": "𝑟", "s": "𝑠", "t": "𝑡",
                "u": "𝑢", "v": "𝑣", "w": "𝑤", "x": "𝑥", "y": "𝑦", "z": "𝑧",
                "A": "𝒜", "B": "𝐵", "C": "𝒞", "D": "𝒟", "E": "𝐸", "F": "𝐹", "G": "𝒢", "H": "𝒲", "I": "𝐼", "J": "𝒥",
                "K": "𝒦", "L": "𝐿", "M": "𝑀", "N": "𝒩", "O": "𝒪", "P": "𝒫", "Q": "𝒬", "R": "𝑅", "S": "𝒮", "T": "𝒯",
                "U": "𝒰", "V": "𝒱", "W": "𝒲", "X": "𝒳", "Y": "𝒴", "Z": "𝒵"
            },
            "bold_italic": {
                "a": "𝒶", "b": "𝒷", "c": "𝒸", "d": "𝒹", "e": "𝑒", "f": "𝒻", "g": "𝒼", "h": "𝒽", "i": "𝒾", "j": "𝒿",
                "k": "𝓀", "l": "𝓁", "m": "𝓂", "n": "𝓃", "o": "𝓸", "p": "𝓅", "q": "𝓆", "r": "𝓇", "s": "𝓈", "t": "𝓉",
                "u": "𝓊", "v": "𝓋", "w": "𝓌", "x": "𝓍", "y": "𝓎", "z": "𝓏",
                "A": "𝒜", "B": "𝒷", "C": "𝒸", "D": "𝒹", "E": "𝒺", "F": "𝒻", "G": "𝒼", "H": "𝒽", "I": "𝒾", "J": "𝒿",
                "K": "𝓀", "L": "𝓁", "M": "𝓂", "N": "𝓃", "O": "𝓸", "P": "𝓅", "Q": "𝓆", "R": "𝓇", "S": "𝓈", "T": "𝓉",
                "U": "𝓊", "V": "𝓋", "W": "𝓌", "X": "𝓍", "Y": "𝓎", "Z": "𝓏"
            },
            "fraktur": {
                "a": "𝖆", "b": "𝖇", "c": "𝖈", "d": "𝖑", "e": "𝖊", "f": "𝖋", "g": "𝖌", "h": "𝖍", "i": "𝖎", "j": "𝖏",
                "k": "𝖐", "l": "𝖑", "m": "𝖒", "n": "𝖓", "o": "𝖔", "p": "𝖕", "q": "𝖖", "r": "𝖗", "s": "𝖘", "t": "𝖙",
                "u": "𝖚", "v": "𝖛", "w": "𝖜", "x": "𝖝", "y": "𝖞", "z": "𝖟",
                "A": "𝖠", "B": "𝖡", "C": "𝖢", "D": "𝖣", "E": "𝖤", "F": "𝖦", "G": "𝖧", "H": "𝖨", "I": "𝖩", "J": "𝖪",
                "K": "𝖫", "L": "𝖬", "M": "𝖭", "N": "𝖮", "O": "𝖱", "P": "𝖲", "Q": "𝖳", "R": "𝖴", "S": "𝖵", "T": "𝖶",
                "U": "𝖷", "V": "𝖸", "W": "𝖹", "X": "𝖺", "Y": "𝖻", "Z": "𝖼"
            },
            "script": {
                "a": "𝒶", "b": "𝒷", "c": "𝒸", "d": "𝒹", "e": "ℯ", "f": "𝒻", "g": "𝒼", "h": "𝒽", "i": "𝒾", "j": "𝒿",
                "k": "𝓀", "l": "𝓁", "m": "𝓂", "n": "𝓃", "o": "𝓸", "p": "𝓅", "q": "𝓆", "r": "𝓇", "s": "𝓈", "t": "𝓉",
                "u": "𝓊", "v": "𝓋", "w": "𝓌", "x": "𝓍", "y": "𝓎", "z": "𝓏",
                "A": "𝒜", "B": "𝐵", "C": "𝒞", "D": "𝒟", "E": "𝐸", "F": "𝐹", "G": "𝒢", "H": "𝒲", "I": "𝐼", "J": "𝒥",
                "K": "𝒦", "L": "𝐿", "M": "𝑀", "N": "𝒩", "O": "𝒪", "P": "𝒫", "Q": "𝒬", "R": "𝑅", "S": "𝒮", "T": "𝒯",
                "U": "𝒰", "V": "𝒱", "W": "𝒲", "X": "𝒳", "Y": "𝒴", "Z": "𝒵"
            },
            "fancy": {
                "a": "𝚊", "b": "𝚋", "c": "𝚌", "d": "𝚍", "e": "𝚎", "f": "𝚏", "g": "𝚐", "h": "𝚑", "i": "𝚒", "j": "𝚓",
                "k": "𝚔", "l": "𝚕", "m": "𝚖", "n": "𝚗", "o": "𝚘", "p": "𝚙", "q": "𝚚", "r": "𝚛", "s": "𝚜", "t": "𝚝",
                "u": "𝚞", "v": "𝚟", "w": "𝚠", "x": "𝚡", "y": "𝚢", "z": "𝚣",
                "A": "𝙰", "B": "𝙱", "C": "𝙲", "D": "𝙳", "E": "𝙴", "F": "𝙵", "G": "𝙶", "H": "𝙷", "I": "𝙸", "J": "𝙹",
                "K": "𝙺", "L": "𝙻", "M": "𝙼", "N": "𝙽", "O": "𝙾", "P": "𝙿", "Q": "𝚀", "R": "𝚁", "S": "𝚂", "T": "𝚃",
                "U": "𝚄", "V": "𝚅", "W": "𝚆", "X": "𝚇", "Y": "𝚈", "Z": "𝚉"
            }
        }
    
    def style(self, text, style_name):
        if style_name not in self.styles:
            raise ValueError(f"الخط '{style_name}' غير موجود. حاول اختيار من {', '.join(self.styles.keys())}.")
        
        styled_text = []
        for char in text:
            if char.lower() in self.styles[style_name]:
                if char.isupper():
                    styled_text.append(self.styles[style_name][char.upper()])
                else:
                    styled_text.append(self.styles[style_name][char.lower()])
            else:
                styled_text.append(char)
        
        return ''.join(styled_text)